"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getVaultNcnTicketEncoder = getVaultNcnTicketEncoder;
exports.getVaultNcnTicketDecoder = getVaultNcnTicketDecoder;
exports.getVaultNcnTicketCodec = getVaultNcnTicketCodec;
exports.decodeVaultNcnTicket = decodeVaultNcnTicket;
exports.fetchVaultNcnTicket = fetchVaultNcnTicket;
exports.fetchMaybeVaultNcnTicket = fetchMaybeVaultNcnTicket;
exports.fetchAllVaultNcnTicket = fetchAllVaultNcnTicket;
exports.fetchAllMaybeVaultNcnTicket = fetchAllMaybeVaultNcnTicket;
const web3_js_1 = require("@solana/web3.js");
const types_1 = require("../types");
function getVaultNcnTicketEncoder() {
    return (0, web3_js_1.getStructEncoder)([
        ['discriminator', (0, web3_js_1.getU64Encoder)()],
        ['vault', (0, web3_js_1.getAddressEncoder)()],
        ['ncn', (0, web3_js_1.getAddressEncoder)()],
        ['index', (0, web3_js_1.getU64Encoder)()],
        ['state', (0, types_1.getSlotToggleEncoder)()],
        ['bump', (0, web3_js_1.getU8Encoder)()],
        ['reserved', (0, web3_js_1.getArrayEncoder)((0, web3_js_1.getU8Encoder)(), { size: 263 })],
    ]);
}
function getVaultNcnTicketDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.getU64Decoder)()],
        ['vault', (0, web3_js_1.getAddressDecoder)()],
        ['ncn', (0, web3_js_1.getAddressDecoder)()],
        ['index', (0, web3_js_1.getU64Decoder)()],
        ['state', (0, types_1.getSlotToggleDecoder)()],
        ['bump', (0, web3_js_1.getU8Decoder)()],
        ['reserved', (0, web3_js_1.getArrayDecoder)((0, web3_js_1.getU8Decoder)(), { size: 263 })],
    ]);
}
function getVaultNcnTicketCodec() {
    return (0, web3_js_1.combineCodec)(getVaultNcnTicketEncoder(), getVaultNcnTicketDecoder());
}
function decodeVaultNcnTicket(encodedAccount) {
    return (0, web3_js_1.decodeAccount)(encodedAccount, getVaultNcnTicketDecoder());
}
async function fetchVaultNcnTicket(rpc, address, config) {
    const maybeAccount = await fetchMaybeVaultNcnTicket(rpc, address, config);
    (0, web3_js_1.assertAccountExists)(maybeAccount);
    return maybeAccount;
}
async function fetchMaybeVaultNcnTicket(rpc, address, config) {
    const maybeAccount = await (0, web3_js_1.fetchEncodedAccount)(rpc, address, config);
    return decodeVaultNcnTicket(maybeAccount);
}
async function fetchAllVaultNcnTicket(rpc, addresses, config) {
    const maybeAccounts = await fetchAllMaybeVaultNcnTicket(rpc, addresses, config);
    (0, web3_js_1.assertAccountsExist)(maybeAccounts);
    return maybeAccounts;
}
async function fetchAllMaybeVaultNcnTicket(rpc, addresses, config) {
    const maybeAccounts = await (0, web3_js_1.fetchEncodedAccounts)(rpc, addresses, config);
    return maybeAccounts.map((maybeAccount) => decodeVaultNcnTicket(maybeAccount));
}
//# sourceMappingURL=vaultNcnTicket.js.map