"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.BURN_WITHDRAWAL_TICKET_DISCRIMINATOR = void 0;
exports.getBurnWithdrawalTicketDiscriminatorBytes = getBurnWithdrawalTicketDiscriminatorBytes;
exports.getBurnWithdrawalTicketInstructionDataEncoder = getBurnWithdrawalTicketInstructionDataEncoder;
exports.getBurnWithdrawalTicketInstructionDataDecoder = getBurnWithdrawalTicketInstructionDataDecoder;
exports.getBurnWithdrawalTicketInstructionDataCodec = getBurnWithdrawalTicketInstructionDataCodec;
exports.getBurnWithdrawalTicketInstruction = getBurnWithdrawalTicketInstruction;
exports.parseBurnWithdrawalTicketInstruction = parseBurnWithdrawalTicketInstruction;
const web3_js_1 = require("@solana/web3.js");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.BURN_WITHDRAWAL_TICKET_DISCRIMINATOR = 14;
function getBurnWithdrawalTicketDiscriminatorBytes() {
    return (0, web3_js_1.getU8Encoder)().encode(exports.BURN_WITHDRAWAL_TICKET_DISCRIMINATOR);
}
function getBurnWithdrawalTicketInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([['discriminator', (0, web3_js_1.getU8Encoder)()]]), (value) => ({
        ...value,
        discriminator: exports.BURN_WITHDRAWAL_TICKET_DISCRIMINATOR,
    }));
}
function getBurnWithdrawalTicketInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([['discriminator', (0, web3_js_1.getU8Decoder)()]]);
}
function getBurnWithdrawalTicketInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getBurnWithdrawalTicketInstructionDataEncoder(), getBurnWithdrawalTicketInstructionDataDecoder());
}
function getBurnWithdrawalTicketInstruction(input) {
    // Program address.
    const programAddress = programs_1.JITO_VAULT_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        config: { value: input.config ?? null, isWritable: false },
        vault: { value: input.vault ?? null, isWritable: true },
        vaultTokenAccount: {
            value: input.vaultTokenAccount ?? null,
            isWritable: true,
        },
        vrtMint: { value: input.vrtMint ?? null, isWritable: true },
        staker: { value: input.staker ?? null, isWritable: true },
        stakerTokenAccount: {
            value: input.stakerTokenAccount ?? null,
            isWritable: true,
        },
        vaultStakerWithdrawalTicket: {
            value: input.vaultStakerWithdrawalTicket ?? null,
            isWritable: true,
        },
        vaultStakerWithdrawalTicketTokenAccount: {
            value: input.vaultStakerWithdrawalTicketTokenAccount ?? null,
            isWritable: true,
        },
        vaultFeeTokenAccount: {
            value: input.vaultFeeTokenAccount ?? null,
            isWritable: true,
        },
        programFeeTokenAccount: {
            value: input.programFeeTokenAccount ?? null,
            isWritable: true,
        },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
        burnSigner: { value: input.burnSigner ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Resolve default values.
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA';
    }
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.config),
            getAccountMeta(accounts.vault),
            getAccountMeta(accounts.vaultTokenAccount),
            getAccountMeta(accounts.vrtMint),
            getAccountMeta(accounts.staker),
            getAccountMeta(accounts.stakerTokenAccount),
            getAccountMeta(accounts.vaultStakerWithdrawalTicket),
            getAccountMeta(accounts.vaultStakerWithdrawalTicketTokenAccount),
            getAccountMeta(accounts.vaultFeeTokenAccount),
            getAccountMeta(accounts.programFeeTokenAccount),
            getAccountMeta(accounts.tokenProgram),
            getAccountMeta(accounts.systemProgram),
            getAccountMeta(accounts.burnSigner),
        ],
        programAddress,
        data: getBurnWithdrawalTicketInstructionDataEncoder().encode({}),
    };
    return instruction;
}
function parseBurnWithdrawalTicketInstruction(instruction) {
    if (instruction.accounts.length < 13) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    const getNextOptionalAccount = () => {
        const accountMeta = getNextAccount();
        return accountMeta.address === programs_1.JITO_VAULT_PROGRAM_ADDRESS
            ? undefined
            : accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            config: getNextAccount(),
            vault: getNextAccount(),
            vaultTokenAccount: getNextAccount(),
            vrtMint: getNextAccount(),
            staker: getNextAccount(),
            stakerTokenAccount: getNextAccount(),
            vaultStakerWithdrawalTicket: getNextAccount(),
            vaultStakerWithdrawalTicketTokenAccount: getNextAccount(),
            vaultFeeTokenAccount: getNextAccount(),
            programFeeTokenAccount: getNextAccount(),
            tokenProgram: getNextAccount(),
            systemProgram: getNextAccount(),
            burnSigner: getNextOptionalAccount(),
        },
        data: getBurnWithdrawalTicketInstructionDataDecoder().decode(instruction.data),
    };
}
//# sourceMappingURL=burnWithdrawalTicket.js.map