/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { JITO_VAULT_PROGRAM_ADDRESS } from '../programs';
export declare const INITIALIZE_VAULT_DISCRIMINATOR = 1;
export declare function getInitializeVaultDiscriminatorBytes(): import("@solana/web3.js").ReadonlyUint8Array;
export type InitializeVaultInstruction<TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS, TAccountConfig extends string | IAccountMeta<string> = string, TAccountVault extends string | IAccountMeta<string> = string, TAccountVrtMint extends string | IAccountMeta<string> = string, TAccountStMint extends string | IAccountMeta<string> = string, TAccountAdminStTokenAccount extends string | IAccountMeta<string> = string, TAccountVaultStTokenAccount extends string | IAccountMeta<string> = string, TAccountBurnVault extends string | IAccountMeta<string> = string, TAccountBurnVaultVrtTokenAccount extends string | IAccountMeta<string> = string, TAccountAdmin extends string | IAccountMeta<string> = string, TAccountBase extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountConfig extends string ? WritableAccount<TAccountConfig> : TAccountConfig,
    TAccountVault extends string ? WritableAccount<TAccountVault> : TAccountVault,
    TAccountVrtMint extends string ? WritableSignerAccount<TAccountVrtMint> & IAccountSignerMeta<TAccountVrtMint> : TAccountVrtMint,
    TAccountStMint extends string ? ReadonlyAccount<TAccountStMint> : TAccountStMint,
    TAccountAdminStTokenAccount extends string ? WritableAccount<TAccountAdminStTokenAccount> : TAccountAdminStTokenAccount,
    TAccountVaultStTokenAccount extends string ? WritableAccount<TAccountVaultStTokenAccount> : TAccountVaultStTokenAccount,
    TAccountBurnVault extends string ? ReadonlyAccount<TAccountBurnVault> : TAccountBurnVault,
    TAccountBurnVaultVrtTokenAccount extends string ? WritableAccount<TAccountBurnVaultVrtTokenAccount> : TAccountBurnVaultVrtTokenAccount,
    TAccountAdmin extends string ? WritableSignerAccount<TAccountAdmin> & IAccountSignerMeta<TAccountAdmin> : TAccountAdmin,
    TAccountBase extends string ? ReadonlySignerAccount<TAccountBase> & IAccountSignerMeta<TAccountBase> : TAccountBase,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    ...TRemainingAccounts
]>;
export type InitializeVaultInstructionData = {
    discriminator: number;
    depositFeeBps: number;
    withdrawalFeeBps: number;
    rewardFeeBps: number;
    decimals: number;
    initializeTokenAmount: bigint;
};
export type InitializeVaultInstructionDataArgs = {
    depositFeeBps: number;
    withdrawalFeeBps: number;
    rewardFeeBps: number;
    decimals: number;
    initializeTokenAmount: number | bigint;
};
export declare function getInitializeVaultInstructionDataEncoder(): Encoder<InitializeVaultInstructionDataArgs>;
export declare function getInitializeVaultInstructionDataDecoder(): Decoder<InitializeVaultInstructionData>;
export declare function getInitializeVaultInstructionDataCodec(): Codec<InitializeVaultInstructionDataArgs, InitializeVaultInstructionData>;
export type InitializeVaultInput<TAccountConfig extends string = string, TAccountVault extends string = string, TAccountVrtMint extends string = string, TAccountStMint extends string = string, TAccountAdminStTokenAccount extends string = string, TAccountVaultStTokenAccount extends string = string, TAccountBurnVault extends string = string, TAccountBurnVaultVrtTokenAccount extends string = string, TAccountAdmin extends string = string, TAccountBase extends string = string, TAccountSystemProgram extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string> = {
    config: Address<TAccountConfig>;
    vault: Address<TAccountVault>;
    vrtMint: TransactionSigner<TAccountVrtMint>;
    stMint: Address<TAccountStMint>;
    adminStTokenAccount: Address<TAccountAdminStTokenAccount>;
    vaultStTokenAccount: Address<TAccountVaultStTokenAccount>;
    burnVault: Address<TAccountBurnVault>;
    burnVaultVrtTokenAccount: Address<TAccountBurnVaultVrtTokenAccount>;
    admin: TransactionSigner<TAccountAdmin>;
    base: TransactionSigner<TAccountBase>;
    systemProgram?: Address<TAccountSystemProgram>;
    tokenProgram?: Address<TAccountTokenProgram>;
    associatedTokenProgram: Address<TAccountAssociatedTokenProgram>;
    depositFeeBps: InitializeVaultInstructionDataArgs['depositFeeBps'];
    withdrawalFeeBps: InitializeVaultInstructionDataArgs['withdrawalFeeBps'];
    rewardFeeBps: InitializeVaultInstructionDataArgs['rewardFeeBps'];
    decimals: InitializeVaultInstructionDataArgs['decimals'];
    initializeTokenAmount: InitializeVaultInstructionDataArgs['initializeTokenAmount'];
};
export declare function getInitializeVaultInstruction<TAccountConfig extends string, TAccountVault extends string, TAccountVrtMint extends string, TAccountStMint extends string, TAccountAdminStTokenAccount extends string, TAccountVaultStTokenAccount extends string, TAccountBurnVault extends string, TAccountBurnVaultVrtTokenAccount extends string, TAccountAdmin extends string, TAccountBase extends string, TAccountSystemProgram extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string>(input: InitializeVaultInput<TAccountConfig, TAccountVault, TAccountVrtMint, TAccountStMint, TAccountAdminStTokenAccount, TAccountVaultStTokenAccount, TAccountBurnVault, TAccountBurnVaultVrtTokenAccount, TAccountAdmin, TAccountBase, TAccountSystemProgram, TAccountTokenProgram, TAccountAssociatedTokenProgram>): InitializeVaultInstruction<typeof JITO_VAULT_PROGRAM_ADDRESS, TAccountConfig, TAccountVault, TAccountVrtMint, TAccountStMint, TAccountAdminStTokenAccount, TAccountVaultStTokenAccount, TAccountBurnVault, TAccountBurnVaultVrtTokenAccount, TAccountAdmin, TAccountBase, TAccountSystemProgram, TAccountTokenProgram, TAccountAssociatedTokenProgram>;
export type ParsedInitializeVaultInstruction<TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        config: TAccountMetas[0];
        vault: TAccountMetas[1];
        vrtMint: TAccountMetas[2];
        stMint: TAccountMetas[3];
        adminStTokenAccount: TAccountMetas[4];
        vaultStTokenAccount: TAccountMetas[5];
        burnVault: TAccountMetas[6];
        burnVaultVrtTokenAccount: TAccountMetas[7];
        admin: TAccountMetas[8];
        base: TAccountMetas[9];
        systemProgram: TAccountMetas[10];
        tokenProgram: TAccountMetas[11];
        associatedTokenProgram: TAccountMetas[12];
    };
    data: InitializeVaultInstructionData;
};
export declare function parseInitializeVaultInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedInitializeVaultInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=initializeVault.d.ts.map