"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.INITIALIZE_VAULT_DISCRIMINATOR = void 0;
exports.getInitializeVaultDiscriminatorBytes = getInitializeVaultDiscriminatorBytes;
exports.getInitializeVaultInstructionDataEncoder = getInitializeVaultInstructionDataEncoder;
exports.getInitializeVaultInstructionDataDecoder = getInitializeVaultInstructionDataDecoder;
exports.getInitializeVaultInstructionDataCodec = getInitializeVaultInstructionDataCodec;
exports.getInitializeVaultInstruction = getInitializeVaultInstruction;
exports.parseInitializeVaultInstruction = parseInitializeVaultInstruction;
const web3_js_1 = require("@solana/web3.js");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.INITIALIZE_VAULT_DISCRIMINATOR = 1;
function getInitializeVaultDiscriminatorBytes() {
    return (0, web3_js_1.getU8Encoder)().encode(exports.INITIALIZE_VAULT_DISCRIMINATOR);
}
function getInitializeVaultInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([
        ['discriminator', (0, web3_js_1.getU8Encoder)()],
        ['depositFeeBps', (0, web3_js_1.getU16Encoder)()],
        ['withdrawalFeeBps', (0, web3_js_1.getU16Encoder)()],
        ['rewardFeeBps', (0, web3_js_1.getU16Encoder)()],
        ['decimals', (0, web3_js_1.getU8Encoder)()],
        ['initializeTokenAmount', (0, web3_js_1.getU64Encoder)()],
    ]), (value) => ({ ...value, discriminator: exports.INITIALIZE_VAULT_DISCRIMINATOR }));
}
function getInitializeVaultInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.getU8Decoder)()],
        ['depositFeeBps', (0, web3_js_1.getU16Decoder)()],
        ['withdrawalFeeBps', (0, web3_js_1.getU16Decoder)()],
        ['rewardFeeBps', (0, web3_js_1.getU16Decoder)()],
        ['decimals', (0, web3_js_1.getU8Decoder)()],
        ['initializeTokenAmount', (0, web3_js_1.getU64Decoder)()],
    ]);
}
function getInitializeVaultInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getInitializeVaultInstructionDataEncoder(), getInitializeVaultInstructionDataDecoder());
}
function getInitializeVaultInstruction(input) {
    // Program address.
    const programAddress = programs_1.JITO_VAULT_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        config: { value: input.config ?? null, isWritable: true },
        vault: { value: input.vault ?? null, isWritable: true },
        vrtMint: { value: input.vrtMint ?? null, isWritable: true },
        stMint: { value: input.stMint ?? null, isWritable: false },
        adminStTokenAccount: {
            value: input.adminStTokenAccount ?? null,
            isWritable: true,
        },
        vaultStTokenAccount: {
            value: input.vaultStTokenAccount ?? null,
            isWritable: true,
        },
        burnVault: { value: input.burnVault ?? null, isWritable: false },
        burnVaultVrtTokenAccount: {
            value: input.burnVaultVrtTokenAccount ?? null,
            isWritable: true,
        },
        admin: { value: input.admin ?? null, isWritable: true },
        base: { value: input.base ?? null, isWritable: false },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
        associatedTokenProgram: {
            value: input.associatedTokenProgram ?? null,
            isWritable: false,
        },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.config),
            getAccountMeta(accounts.vault),
            getAccountMeta(accounts.vrtMint),
            getAccountMeta(accounts.stMint),
            getAccountMeta(accounts.adminStTokenAccount),
            getAccountMeta(accounts.vaultStTokenAccount),
            getAccountMeta(accounts.burnVault),
            getAccountMeta(accounts.burnVaultVrtTokenAccount),
            getAccountMeta(accounts.admin),
            getAccountMeta(accounts.base),
            getAccountMeta(accounts.systemProgram),
            getAccountMeta(accounts.tokenProgram),
            getAccountMeta(accounts.associatedTokenProgram),
        ],
        programAddress,
        data: getInitializeVaultInstructionDataEncoder().encode(args),
    };
    return instruction;
}
function parseInitializeVaultInstruction(instruction) {
    if (instruction.accounts.length < 13) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            config: getNextAccount(),
            vault: getNextAccount(),
            vrtMint: getNextAccount(),
            stMint: getNextAccount(),
            adminStTokenAccount: getNextAccount(),
            vaultStTokenAccount: getNextAccount(),
            burnVault: getNextAccount(),
            burnVaultVrtTokenAccount: getNextAccount(),
            admin: getNextAccount(),
            base: getNextAccount(),
            systemProgram: getNextAccount(),
            tokenProgram: getNextAccount(),
            associatedTokenProgram: getNextAccount(),
        },
        data: getInitializeVaultInstructionDataDecoder().decode(instruction.data),
    };
}
//# sourceMappingURL=initializeVault.js.map