"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MINT_TO_DISCRIMINATOR = void 0;
exports.getMintToDiscriminatorBytes = getMintToDiscriminatorBytes;
exports.getMintToInstructionDataEncoder = getMintToInstructionDataEncoder;
exports.getMintToInstructionDataDecoder = getMintToInstructionDataDecoder;
exports.getMintToInstructionDataCodec = getMintToInstructionDataCodec;
exports.getMintToInstruction = getMintToInstruction;
exports.parseMintToInstruction = parseMintToInstruction;
const web3_js_1 = require("@solana/web3.js");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.MINT_TO_DISCRIMINATOR = 11;
function getMintToDiscriminatorBytes() {
    return (0, web3_js_1.getU8Encoder)().encode(exports.MINT_TO_DISCRIMINATOR);
}
function getMintToInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([
        ['discriminator', (0, web3_js_1.getU8Encoder)()],
        ['amountIn', (0, web3_js_1.getU64Encoder)()],
        ['minAmountOut', (0, web3_js_1.getU64Encoder)()],
    ]), (value) => ({ ...value, discriminator: exports.MINT_TO_DISCRIMINATOR }));
}
function getMintToInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.getU8Decoder)()],
        ['amountIn', (0, web3_js_1.getU64Decoder)()],
        ['minAmountOut', (0, web3_js_1.getU64Decoder)()],
    ]);
}
function getMintToInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getMintToInstructionDataEncoder(), getMintToInstructionDataDecoder());
}
function getMintToInstruction(input) {
    // Program address.
    const programAddress = programs_1.JITO_VAULT_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        config: { value: input.config ?? null, isWritable: false },
        vault: { value: input.vault ?? null, isWritable: true },
        vrtMint: { value: input.vrtMint ?? null, isWritable: true },
        depositor: { value: input.depositor ?? null, isWritable: true },
        depositorTokenAccount: {
            value: input.depositorTokenAccount ?? null,
            isWritable: true,
        },
        vaultTokenAccount: {
            value: input.vaultTokenAccount ?? null,
            isWritable: true,
        },
        depositorVrtTokenAccount: {
            value: input.depositorVrtTokenAccount ?? null,
            isWritable: true,
        },
        vaultFeeTokenAccount: {
            value: input.vaultFeeTokenAccount ?? null,
            isWritable: true,
        },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
        mintSigner: { value: input.mintSigner ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.config),
            getAccountMeta(accounts.vault),
            getAccountMeta(accounts.vrtMint),
            getAccountMeta(accounts.depositor),
            getAccountMeta(accounts.depositorTokenAccount),
            getAccountMeta(accounts.vaultTokenAccount),
            getAccountMeta(accounts.depositorVrtTokenAccount),
            getAccountMeta(accounts.vaultFeeTokenAccount),
            getAccountMeta(accounts.tokenProgram),
            getAccountMeta(accounts.mintSigner),
        ],
        programAddress,
        data: getMintToInstructionDataEncoder().encode(args),
    };
    return instruction;
}
function parseMintToInstruction(instruction) {
    if (instruction.accounts.length < 10) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    const getNextOptionalAccount = () => {
        const accountMeta = getNextAccount();
        return accountMeta.address === programs_1.JITO_VAULT_PROGRAM_ADDRESS
            ? undefined
            : accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            config: getNextAccount(),
            vault: getNextAccount(),
            vrtMint: getNextAccount(),
            depositor: getNextAccount(),
            depositorTokenAccount: getNextAccount(),
            vaultTokenAccount: getNextAccount(),
            depositorVrtTokenAccount: getNextAccount(),
            vaultFeeTokenAccount: getNextAccount(),
            tokenProgram: getNextAccount(),
            mintSigner: getNextOptionalAccount(),
        },
        data: getMintToInstructionDataDecoder().decode(instruction.data),
    };
}
//# sourceMappingURL=mintTo.js.map