/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  combineCodec,
  getStructDecoder,
  getStructEncoder,
  getU8Decoder,
  getU8Encoder,
  transformEncoder,
  type Address,
  type Codec,
  type Decoder,
  type Encoder,
  type IAccountMeta,
  type IAccountSignerMeta,
  type IInstruction,
  type IInstructionWithAccounts,
  type IInstructionWithData,
  type ReadonlyAccount,
  type ReadonlySignerAccount,
  type TransactionSigner,
  type WritableAccount,
} from '@solana/web3.js';
import { JITO_VAULT_PROGRAM_ADDRESS } from '../programs';
import { getAccountMetaFactory, type ResolvedAccount } from '../shared';

export const WARMUP_VAULT_NCN_TICKET_DISCRIMINATOR = 7;

export function getWarmupVaultNcnTicketDiscriminatorBytes() {
  return getU8Encoder().encode(WARMUP_VAULT_NCN_TICKET_DISCRIMINATOR);
}

export type WarmupVaultNcnTicketInstruction<
  TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountConfig extends string | IAccountMeta<string> = string,
  TAccountVault extends string | IAccountMeta<string> = string,
  TAccountNcn extends string | IAccountMeta<string> = string,
  TAccountVaultNcnTicket extends string | IAccountMeta<string> = string,
  TAccountAdmin extends string | IAccountMeta<string> = string,
  TRemainingAccounts extends readonly IAccountMeta<string>[] = [],
> = IInstruction<TProgram> &
  IInstructionWithData<Uint8Array> &
  IInstructionWithAccounts<
    [
      TAccountConfig extends string
        ? ReadonlyAccount<TAccountConfig>
        : TAccountConfig,
      TAccountVault extends string
        ? WritableAccount<TAccountVault>
        : TAccountVault,
      TAccountNcn extends string ? ReadonlyAccount<TAccountNcn> : TAccountNcn,
      TAccountVaultNcnTicket extends string
        ? WritableAccount<TAccountVaultNcnTicket>
        : TAccountVaultNcnTicket,
      TAccountAdmin extends string
        ? ReadonlySignerAccount<TAccountAdmin> &
            IAccountSignerMeta<TAccountAdmin>
        : TAccountAdmin,
      ...TRemainingAccounts,
    ]
  >;

export type WarmupVaultNcnTicketInstructionData = { discriminator: number };

export type WarmupVaultNcnTicketInstructionDataArgs = {};

export function getWarmupVaultNcnTicketInstructionDataEncoder(): Encoder<WarmupVaultNcnTicketInstructionDataArgs> {
  return transformEncoder(
    getStructEncoder([['discriminator', getU8Encoder()]]),
    (value) => ({
      ...value,
      discriminator: WARMUP_VAULT_NCN_TICKET_DISCRIMINATOR,
    })
  );
}

export function getWarmupVaultNcnTicketInstructionDataDecoder(): Decoder<WarmupVaultNcnTicketInstructionData> {
  return getStructDecoder([['discriminator', getU8Decoder()]]);
}

export function getWarmupVaultNcnTicketInstructionDataCodec(): Codec<
  WarmupVaultNcnTicketInstructionDataArgs,
  WarmupVaultNcnTicketInstructionData
> {
  return combineCodec(
    getWarmupVaultNcnTicketInstructionDataEncoder(),
    getWarmupVaultNcnTicketInstructionDataDecoder()
  );
}

export type WarmupVaultNcnTicketInput<
  TAccountConfig extends string = string,
  TAccountVault extends string = string,
  TAccountNcn extends string = string,
  TAccountVaultNcnTicket extends string = string,
  TAccountAdmin extends string = string,
> = {
  config: Address<TAccountConfig>;
  vault: Address<TAccountVault>;
  ncn: Address<TAccountNcn>;
  vaultNcnTicket: Address<TAccountVaultNcnTicket>;
  admin: TransactionSigner<TAccountAdmin>;
};

export function getWarmupVaultNcnTicketInstruction<
  TAccountConfig extends string,
  TAccountVault extends string,
  TAccountNcn extends string,
  TAccountVaultNcnTicket extends string,
  TAccountAdmin extends string,
>(
  input: WarmupVaultNcnTicketInput<
    TAccountConfig,
    TAccountVault,
    TAccountNcn,
    TAccountVaultNcnTicket,
    TAccountAdmin
  >
): WarmupVaultNcnTicketInstruction<
  typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountConfig,
  TAccountVault,
  TAccountNcn,
  TAccountVaultNcnTicket,
  TAccountAdmin
> {
  // Program address.
  const programAddress = JITO_VAULT_PROGRAM_ADDRESS;

  // Original accounts.
  const originalAccounts = {
    config: { value: input.config ?? null, isWritable: false },
    vault: { value: input.vault ?? null, isWritable: true },
    ncn: { value: input.ncn ?? null, isWritable: false },
    vaultNcnTicket: { value: input.vaultNcnTicket ?? null, isWritable: true },
    admin: { value: input.admin ?? null, isWritable: false },
  };
  const accounts = originalAccounts as Record<
    keyof typeof originalAccounts,
    ResolvedAccount
  >;

  const getAccountMeta = getAccountMetaFactory(programAddress, 'programId');
  const instruction = {
    accounts: [
      getAccountMeta(accounts.config),
      getAccountMeta(accounts.vault),
      getAccountMeta(accounts.ncn),
      getAccountMeta(accounts.vaultNcnTicket),
      getAccountMeta(accounts.admin),
    ],
    programAddress,
    data: getWarmupVaultNcnTicketInstructionDataEncoder().encode({}),
  } as WarmupVaultNcnTicketInstruction<
    typeof JITO_VAULT_PROGRAM_ADDRESS,
    TAccountConfig,
    TAccountVault,
    TAccountNcn,
    TAccountVaultNcnTicket,
    TAccountAdmin
  >;

  return instruction;
}

export type ParsedWarmupVaultNcnTicketInstruction<
  TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[],
> = {
  programAddress: Address<TProgram>;
  accounts: {
    config: TAccountMetas[0];
    vault: TAccountMetas[1];
    ncn: TAccountMetas[2];
    vaultNcnTicket: TAccountMetas[3];
    admin: TAccountMetas[4];
  };
  data: WarmupVaultNcnTicketInstructionData;
};

export function parseWarmupVaultNcnTicketInstruction<
  TProgram extends string,
  TAccountMetas extends readonly IAccountMeta[],
>(
  instruction: IInstruction<TProgram> &
    IInstructionWithAccounts<TAccountMetas> &
    IInstructionWithData<Uint8Array>
): ParsedWarmupVaultNcnTicketInstruction<TProgram, TAccountMetas> {
  if (instruction.accounts.length < 5) {
    // TODO: Coded error.
    throw new Error('Not enough accounts');
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts![accountIndex]!;
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      config: getNextAccount(),
      vault: getNextAccount(),
      ncn: getNextAccount(),
      vaultNcnTicket: getNextAccount(),
      admin: getNextAccount(),
    },
    data: getWarmupVaultNcnTicketInstructionDataDecoder().decode(
      instruction.data
    ),
  };
}
